#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

#include "cycletime.h"
#include "walltime.h"

int main(int argc, char* argv[])
{
    double w_start = 0.0, w_end = 0.0;
    unsigned long c_start = 0, c_end = 0;

    w_start = timestamp();
    c_start = cyclestamp();
    printf("Timestamp (Before): %f\n", w_start);
    printf("Cyclestamp (Before): %lu\n", c_start);


    sleep(1);

    c_end = cyclestamp();
    w_end = timestamp();

    printf("Timestamp (After): %f\n", w_end);
    printf("Cyclestamp (After): %lu\n", c_end);
    printf("----------------\n");
    printf("TIME: %f s\n", w_end-w_start);
    printf("CYCLES: %lu\n", c_end-c_start);
    printf("Mean frequency (CYCLES/TIME): %.01f GHz\n", 1E-9*(c_end-c_start)/(w_end-w_start));
    return 0;
}
